import os.path
import pygame.mixer
import Event

class MusicView(object):
    '''Music playing class.'''
    def __init__(self):
        pygame.mixer.init(48000, -16, 2, 1024*3)
        self.musicchan = pygame.mixer.Channel(0)
        self.playingsong = None
        self.sounds = {}
        self.filecache = {}

    def get_cache(self, filename):
        if self.filecache.has_key(filename):
            return self.filecache[filename]
        else:
            s = pygame.mixer.Sound(os.path.join('sounds', filename))
            self.filecache[filename] = s
            return s
                                  

    def Notify(self, event):
        if isinstance(event, Event.NewSoundEvent):
            if event.loop:
                loop = -1
            else:
                loop = 0
            if not event.music:
                f = event.file.replace('wav', 'ogg')
                s = self.get_cache(f)
                event.sound = s
                c = pygame.mixer.find_channel()
                if c == None: return # Meh
                c.play(s, loop)
                self.sounds[event.file] = s
                return
            if self.playingsong != event.file:
                self.playingsong = event.file
                pygame.mixer.music.load(os.path.join('music', event.file))
                pygame.mixer.music.set_volume(.8)
                pygame.mixer.music.play(loop)

        if isinstance(event, Event.StopSoundEvent):
            if self.sounds.has_key(event.file):
                self.sounds[event.file].stop()
                del self.sounds[event.file]
